#include <stdio.h>
#include "md5.h"
#include <set>

using namespace std;

unsigned char start[16];


struct Digest
{
	unsigned char src[16];
	unsigned char dest[16];
	bool operator==(const Digest& other)
	{
		return memcmp(dest, other.dest, 16)==0;
	}
};

struct DigestComp
{
	bool operator()(const Digest& first, const Digest& second)
	{
		return memcmp(first.dest, second.dest, 16)<0;
	}
};

typedef set<Digest, DigestComp> md5Set;


void init(md5Set& mySet, Digest& digest)
{
	md5_state_t state;

	memset(digest.src, 0, 16);
	md5_init(&state);
	md5_append(&state, digest.src, 16);
	md5_finish(&state, digest.dest);
	mySet.insert(digest);
}

void 

void repeat()
{
	pair<md5Set::iterator, bool> result;
	md5Set* pMySet;
	Digest start, digest;
	int counter=0, i;
	md5_state_t state;

	pMySet=new md5Set;
	init(*pMySet, start);
	memcpy(&digest.src, &start.dest, sizeof(Digest));
	
	do
	{
		md5_init(&state);
		md5_append(&state, digest.src, 16);
		md5_finish(&state, digest.dest);
		
		result=pMySet->insert(digest);
	
		counter++;
		if (counter%1000==0)
		{
			printf("counter=%d\n", counter);
		}
		memcpy(digest.src, digest.dest, 16);
	}
	while (result.second);

	printf("found? counter=%d\n", counter);
	printf("src[");
	for (i=0; i<16; i++)
	{
		printf("%c", digest.src[i]);
	}
	printf("]\n");
	printf("dest[");
	for (i=0; i<16; i++)
	{
		printf("%c", digest.dest[i]);
	}
	printf("]\n");
}


int main()
{

	repeat();
	return 0;
}
	

